
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, March 2003
//              mailto: anthony@softbolts.com
//
//		Last Revised: 4th March 2003
//
//-----------------------------------------------------------

package com.softbolts.connectors.TBDB;

import com.softbolts.lib.*;

import java.io.*;
import java.util.*;
//import java.lang.*;
import java.sql.*;


public class DBPoller extends Thread 
{
 PollerState pollerState = null;
 String transName = null;
 int pollingInterval = 0;
 String instanceName = null;
 Connection conn = null;
 Statement stmt = null;
 ResultSet rset = null;
 String shadowTableName = null;
 String triggerName = null;
 int enginePort = 0;
 String engineHostName = null;
 TDBInfo di;
 String table = null;
 String connectionStr = null;
 String login = null;
 String passwd = null;


        //-----------------------------------------------------------
        public DBPoller(PollerState pollerState, int pollingInterval, String transName, 
				String instanceName, String connectionStr, String shadowTableName,
				String triggerName, int enginePort, String engineHostName,
				TDBInfo di, String table, String login, String passwd) throws ThrowableString
        {
		this.pollerState = pollerState;
		this.pollingInterval = pollingInterval;
		this.transName = transName;
		this.instanceName = instanceName;
		this.connectionStr = connectionStr;
		this.shadowTableName = shadowTableName;
		this.triggerName = triggerName;
		this.enginePort = enginePort;
		this.engineHostName = engineHostName;
		this.di = di;
		this.table = table;
		this.login = login;
		this.passwd = passwd;

                try {
                        DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
                        //conn = DriverManager.getConnection ("jdbc:oracle:thin:@ganymede:1521:CCDB1", "csr", "andiamoa");
                        conn = DriverManager.getConnection (connectionStr, login, passwd);
                        stmt = conn.createStatement();

                } catch (SQLException ex) {
			System.out.println("ERR: TBDB.Servlet::DBPoller() - SQLException: " + ex.getMessage());
                }

		pollerState.set();
        }

        //-----------------------------------------------------------
        public void Sleep(long interval)
        {
		try {
			sleep(interval);		// thousands of one second
		} catch (InterruptedException ie) {
			System.err.println("TBDB.DBPoller::run() - InterruptedException on call to sleep()");
		}
	}

        //-----------------------------------------------------------
        public void run()
        {
	 //File fileDir = null;
	 NameValueTyp tmpMap = new NameValueTyp();
	 SocketObj sok = null;
	 TTable tab = di.td.get(table);
	 String colName = "";
	 String statement = "";

		System.err.println("TBDB.DBPoller::run()");

		while (pollerState.test())
		{
			System.out.println("TBDB.DBPoller::run() -> " + instanceName + " Polling...");
			System.err.println("TBDB.DBPoller::run() -> " + instanceName + " Polling...");

			try {
				//stmt.executeQuery("start");
				statement = "select * from " + shadowTableName;
				rset = stmt.executeQuery(statement);
				statement = "delete from " + shadowTableName;
				stmt.executeQuery(statement);
				//stmt.executeQuery("commit");
			} catch (SQLException ex) {
				System.out.println("ERR: -select- TBDB.DBPoller::run() - SQLException: " + 
						ex.getMessage() + "SQL Statement was: " + statement);
				try {
					stmt.executeQuery("rollback");
				} catch (SQLException e) {
					System.out.println("ERR: -rollback- TBDB.DBPoller::run() - SQLException: " + 
							e.getMessage() + "SQL Statement was: " + statement);
				}

				// TO DO take this connector off line when there is an exception
				Sleep(5000);
				break;
			}

			// TO DO could potentially lose data here if the connection to the server fails and 
			// we have already deleted all the rows from the shadow table
			try {
				while (rset.next())
				{
												// add to the map all the fields 
												// we have found in the result set
					tmpMap.clear();
					Enumeration ce = tab.keys();
					while (ce.hasMoreElements())
					{
						colName = (String) ce.nextElement();
						tmpMap.put(colName, rset.getString(colName));
					}

					tmpMap.put("sysTransName", transName);
					tmpMap.put("sysClientId", instanceName);
					tmpMap.put("sysDebug", "True");
					tmpMap.put("sysReply", "True");

	PersistStream.printMap(tmpMap);
					try {
						sok = new SocketObj(enginePort, engineHostName);
						if (sok.connected)
						{
							sok.write(tmpMap);
							sok.read(tmpMap);
							sok.close();
						}
						else // (!sok.connected)
						{
							tmpMap.put("sysResultStatus", "-1");
							tmpMap.put("sysResultString", "Socket Connection failed");
						}

					} catch (ThrowableString e) {
						System.err.println("DBPoller::run() - " + e.getMessage());
					} catch (IOException ioe) {
						System.err.println("DBPoller::run() - No Engine Found " + ioe.getMessage());
					}

					if (tmpMap.containsKey("sysResultStatus") && tmpMap.get("sysResultStatus").equals("-1"))
					{
						System.err.println("Servlet::checkModel() - Cannot run requested transaction model " +
									 tmpMap.get("sysResultString"));
					}
				}
			} catch (SQLException ex) {
				System.out.println("ERR: -rset.next()- TBDB.DBPoller::run() - SQLException: " + ex.getMessage());
			}

			try{
				stmt.executeQuery("commit");
				rset.close();
			} catch (SQLException ex) {
				System.out.println("ERR: -stmt.commit() OR rset.close() - TBDB.DBPoller::run() - SQLException: " + 
					ex.getMessage());
			}

			Sleep(pollingInterval * 1000);
		}

		System.out.println("TBDB.DBPoller::run() - Poller stopping");
		System.err.println("TBDB.DBPoller::run() - Poller stopping");

		System.out.println("TBDB.DBPoller::run() - clearing shadowtable and trigger");
		System.err.println("TBDB.DBPoller::run() - clearing shadowtable and trigger");
		try {
			stmt.executeQuery("drop trigger " + triggerName);
			stmt.executeQuery("drop table " + shadowTableName);
			rset = stmt.executeQuery("commit");
			conn.close();
		} catch (SQLException ex) {
			System.out.println("ERR: TBDB.Servlet::getTable() - SQLException: " + ex.getMessage());
		}
		pollerState.set();
	}
}

