
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Oct 2002 
//              mailto: anthony@softbolts.com
//
//		Last Revised: 14 Oct 2002
//
//-----------------------------------------------------------

package com.softbolts.connectors.TBDB;

import com.softbolts.lib.*;
import java.io.*;
import java.net.*;
//import java.util.*;
//import java.text.*;
//import java.lang.*;

//-----------------------------------------------------------
/**
* This is a generic jdbc base database connector. 
* Parameters that may be set in the property sheet for this connector
* are the following:
* <p>1) Driver Class Name - This is the name of the JDCB driver class to use. Some valid drivers are: "oracle.jdbc.driver.OracleDriver" 
* for Oracle and "com.mysql.jdbc.Driver" for mysql.
* <br>2) Execute Model - This is the transaction model to be executed when the connector is acting as a trigger source.
* <br>3) Host Name - This is the name of the machine on which the DB is to be found.
* <br>5) JDBC Driver URL - This is the jdbc URL to use. Some valid URLs are: 
* "jdbc:oracle:thin:@ganymede:SOCKET# (eg.1521):DB_SID (eg.CCDB1)" for Oracle and "jdbc:mysql://HOST (eg. ganymede)/DB_ID (eg. test)" or 
* <br>6) Login - This is the login to the database, it may be included in the URL.
* <br>7) Password - This is the password to the login, it may be included in the URL.
* <br>8) Polling Interval - This is the pollign interval to be used when the connector is acting as a trigger source.
* <br>9) SQL Statement - This is the SQL statement to be used when calling a set or get object method.
* <br>10) Source or Target - If the connector is to act as a source or target.
* <br>11) Trigger table - this is the table to poll on when the connector is acting as a trigger source.
* <b><H1>Operational Behaviour</H1>
* <b>a) This is determined by the connector's configuration. If the connector is configure to be a
* non trigger and the SQL statement has been initialized or the key string SQL_STATEMENT is passed to the
* connector in the input map then the connector will simply run the sql statement and return the data
* in the output map.
* <br>a.1) If the Sql statement has not been entered in the property sheet the connector will look for the key
* SQL_STATEMENT in its input map and use that.
* <br>a.2) If neither sql statement has been entered in the property sheet or in the call to the trassaction
* though the SQL_STATEMENT key name the connector will use "select * from table_name" where the table name is the
* table name entered in the property sheet. If no table name has been entered the connector will quietly do nothing!
* <br>b) If the connector is set up as a trigger source, it will automatically set up a shadow table and a
* database trigger against the table specified in the Trigger Table property. Whenever a record is added, inserted
* or updated the transaction model specified in the Execute Model property will be run with data set
* that caused the trigger to occur.
* <br>
*
*/
public class TBDB
{
        static public void main(String args[])
        {
		Servlet svr = new Servlet(args);

		try {
			ServletRunner sr = new ServletRunner(svr, args);
			sr.run();
		} catch (ThrowableString s) {
			System.err.println(s.getMessage());
		}
        }
}


